"""autogenerated by genmsg_py from CartesianPose.msg. Do not edit."""
import roslib.message
import struct

import brics_actuator.msg
import geometry_msgs.msg
import roslib.rostime

class CartesianPose(roslib.message.Message):
  _md5sum = "0fe287468091771914ed98dea2d2a5a5"
  _type = "brics_actuator/CartesianPose"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """time timeStamp
Poison poisonStamp
string base_frame_uri
string target_frame_uri
CartesianVector position
geometry_msgs/Quaternion orientation

================================================================================
MSG: brics_actuator/Poison
string originator 		# node id
string description 		# encoding still an issue
float32 qos			# reliability of the channel
				# 0..1 where 1 means healthy

================================================================================
MSG: brics_actuator/CartesianVector
string unit
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['timeStamp','poisonStamp','base_frame_uri','target_frame_uri','position','orientation']
  _slot_types = ['time','brics_actuator/Poison','string','string','brics_actuator/CartesianVector','geometry_msgs/Quaternion']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       timeStamp,poisonStamp,base_frame_uri,target_frame_uri,position,orientation
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(CartesianPose, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.timeStamp is None:
        self.timeStamp = roslib.rostime.Time()
      if self.poisonStamp is None:
        self.poisonStamp = brics_actuator.msg.Poison()
      if self.base_frame_uri is None:
        self.base_frame_uri = ''
      if self.target_frame_uri is None:
        self.target_frame_uri = ''
      if self.position is None:
        self.position = brics_actuator.msg.CartesianVector()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Quaternion()
    else:
      self.timeStamp = roslib.rostime.Time()
      self.poisonStamp = brics_actuator.msg.Poison()
      self.base_frame_uri = ''
      self.target_frame_uri = ''
      self.position = brics_actuator.msg.CartesianVector()
      self.orientation = geometry_msgs.msg.Quaternion()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_2I.pack(_x.timeStamp.secs, _x.timeStamp.nsecs))
      _x = self.poisonStamp.originator
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.poisonStamp.description
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_f.pack(self.poisonStamp.qos))
      _x = self.base_frame_uri
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.target_frame_uri
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.position.unit
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.position.x, _x.position.y, _x.position.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation.w))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.timeStamp is None:
        self.timeStamp = roslib.rostime.Time()
      if self.poisonStamp is None:
        self.poisonStamp = brics_actuator.msg.Poison()
      if self.position is None:
        self.position = brics_actuator.msg.CartesianVector()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Quaternion()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timeStamp.secs, _x.timeStamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.poisonStamp.originator = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.poisonStamp.description = str[start:end]
      start = end
      end += 4
      (self.poisonStamp.qos,) = _struct_f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.base_frame_uri = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.target_frame_uri = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.position.unit = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.position.x, _x.position.y, _x.position.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation.w,) = _struct_7d.unpack(str[start:end])
      self.timeStamp.canon()
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_2I.pack(_x.timeStamp.secs, _x.timeStamp.nsecs))
      _x = self.poisonStamp.originator
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.poisonStamp.description
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_f.pack(self.poisonStamp.qos))
      _x = self.base_frame_uri
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.target_frame_uri
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.position.unit
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.position.x, _x.position.y, _x.position.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation.w))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.timeStamp is None:
        self.timeStamp = roslib.rostime.Time()
      if self.poisonStamp is None:
        self.poisonStamp = brics_actuator.msg.Poison()
      if self.position is None:
        self.position = brics_actuator.msg.CartesianVector()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Quaternion()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timeStamp.secs, _x.timeStamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.poisonStamp.originator = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.poisonStamp.description = str[start:end]
      start = end
      end += 4
      (self.poisonStamp.qos,) = _struct_f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.base_frame_uri = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.target_frame_uri = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.position.unit = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.position.x, _x.position.y, _x.position.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation.w,) = _struct_7d.unpack(str[start:end])
      self.timeStamp.canon()
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_7d = struct.Struct("<7d")
_struct_2I = struct.Struct("<2I")
_struct_f = struct.Struct("<f")
